Index: XIOS/dev/branch_openmp/src/node/domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/node/domain.cpp	(revision 1556)
+++ XIOS/dev/branch_openmp/src/node/domain.cpp	(revision 1642)
@@ -1734,155 +1850,110 @@
         if (indSrv_.find(nbServer) == indSrv_.end())
         {
-          int i,j,i_ind,j_ind, nbIndex, nbIndexZoom;
-          int global_zoom_iend=global_zoom_ibegin+global_zoom_ni-1;
-          int global_zoom_jend=global_zoom_jbegin+global_zoom_nj-1;
-
-           // Precompute number of index
-           int globalIndexCountZoom = 0;
-           nbIndex = i_index.numElements();
-
-           if (doZoomByIndex_)
-           {
-             globalIndexCountZoom = zoom_i_index.numElements();
-           }
-           else
-           {
-             for (i = 0; i < nbIndex; ++i)
-             {
-               i_ind=i_index(i);
-               j_ind=j_index(i);
-
-               if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
-               {
-                  ++globalIndexCountZoom;
-               }
-             }
-           }
-
-           // Fill in index
-           CArray<size_t,1> globalIndexDomainZoom(globalIndexCountZoom);
-           CArray<size_t,1> localIndexDomainZoom(globalIndexCountZoom);
-           CArray<size_t,1> globalIndexDomain(nbIndex);
-           size_t globalIndex;
-           int globalIndexCount = 0;
-
-           for (i = 0; i < nbIndex; ++i)
-           {
-             i_ind=i_index(i);
-             j_ind=j_index(i);
-             globalIndex = i_ind + j_ind * ni_glo;
-             globalIndexDomain(i) = globalIndex;
-           }
-
-           if (globalLocalIndexMap_.empty())
-           {
-             for (i = 0; i < nbIndex; ++i)
-               globalLocalIndexMap_[globalIndexDomain(i)] = i;
-           }
-
-           globalIndexCountZoom = 0;
-           if (doZoomByIndex_)
-           {
-             int nbIndexZoom = zoom_i_index.numElements();
-
-             for (i = 0; i < nbIndexZoom; ++i)
-             {
-               i_ind=zoom_i_index(i);
-               j_ind=zoom_j_index(i);
-               globalIndex = i_ind + j_ind * ni_glo;
-               globalIndexDomainZoom(globalIndexCountZoom) = globalIndex;
-               ++globalIndexCountZoom;
-             }
-           }
-           else
-           {
-             int global_zoom_iend=global_zoom_ibegin+global_zoom_ni-1;
-             int global_zoom_jend=global_zoom_jbegin+global_zoom_nj-1;
-             for (i = 0; i < nbIndex; ++i)
-             {
-               i_ind=i_index(i);
-               j_ind=j_index(i);
-               globalIndex = i_ind + j_ind * ni_glo;
-               if (i_ind >= global_zoom_ibegin && i_ind <= global_zoom_iend && j_ind >= global_zoom_jbegin && j_ind <= global_zoom_jend)
-               {
-                  globalIndexDomainZoom(globalIndexCountZoom) = globalIndex;
-                  ++globalIndexCountZoom;
-               }
-             }
-
-             int iend = ibegin + ni -1;
-             int jend = jbegin + nj -1;
-             zoom_ibegin = global_zoom_ibegin > ibegin ? global_zoom_ibegin.getValue() : ibegin;
-             int zoom_iend  = global_zoom_iend < iend ? zoom_iend : iend ;
-             zoom_ni     = zoom_iend-zoom_ibegin+1 ;
-
-             zoom_jbegin = global_zoom_jbegin > jbegin ? global_zoom_jbegin.getValue() : jbegin ;
-             int zoom_jend   = global_zoom_jend < jend ? zoom_jend : jend;
-             zoom_nj     = zoom_jend-zoom_jbegin+1;
-           }
-
-           size_t globalSizeIndex = 1, indexBegin, indexEnd;
-           int range, clientSize = client->clientSize;
-           std::vector<int> nGlobDomain(2);
-           nGlobDomain[0] = this->ni_glo;
-           nGlobDomain[1] = this->nj_glo;
-           for (int i = 0; i < nGlobDomain.size(); ++i) globalSizeIndex *= nGlobDomain[i];
-           indexBegin = 0;
-           if (globalSizeIndex <= clientSize)
-           {
-             indexBegin = rank%globalSizeIndex;
-             indexEnd = indexBegin;
-           }
-           else
-           {
-             for (int i = 0; i < clientSize; ++i)
-             {
-               range = globalSizeIndex / clientSize;
-               if (i < (globalSizeIndex%clientSize)) ++range;
-               if (i == client->clientRank) break;
-               indexBegin += range;
-             }
-             indexEnd = indexBegin + range - 1;
-           }
-
-           // Even if servers have no index, they must received something from client
-           // We only use several client to send "empty" message to these servers
-           CServerDistributionDescription serverDescription(nGlobDomain, nbServer);
-           std::vector<int> serverZeroIndex;
-           if (isUnstructed_) serverZeroIndex = serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t&,size_t&>(indexBegin, indexEnd), 0);
-           else serverZeroIndex = serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t&,size_t&>(indexBegin, indexEnd), 1);
-
-           std::list<int> serverZeroIndexLeader;
-           std::list<int> serverZeroIndexNotLeader;
-           CContextClient::computeLeader(client->clientRank, client->clientSize, serverZeroIndex.size(), serverZeroIndexLeader, serverZeroIndexNotLeader);
-           for (std::list<int>::iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
-              *it = serverZeroIndex[*it];
-
-           CClientServerMapping* clientServerMap = new CClientServerMappingDistributed(serverDescription.getGlobalIndexRange(),
-                 client->intraComm);
-           clientServerMap->computeServerIndexMapping(globalIndexDomain, nbServer);
-           CClientServerMapping::GlobalIndexMap& globalIndexDomainOnServer = clientServerMap->getGlobalIndexOnServer();
-
-           CClientServerMapping::GlobalIndexMap::const_iterator it  = globalIndexDomainOnServer.begin(),
+          int i,j,i_ind,j_ind, nbIndex=i_index.numElements();
+          int globalIndexCount = i_index.numElements();
+          // Fill in index
+          CArray<size_t,1> globalIndexDomain(nbIndex);
+          size_t globalIndex;
+
+          for (i = 0; i < nbIndex; ++i)
+          {
+            i_ind=i_index(i);
+            j_ind=j_index(i);
+            globalIndex = i_ind + j_ind * ni_glo;
+            globalIndexDomain(i) = globalIndex;
+          }
+
+          if (globalLocalIndexMap_.empty())
+          {
+            for (i = 0; i < nbIndex; ++i)
+              globalLocalIndexMap_[globalIndexDomain(i)] = i;
+          }
+
+          size_t globalSizeIndex = 1, indexBegin, indexEnd;
+          int range, clientSize = client->clientSize;
+          std::vector<int> nGlobDomain(2);
+          nGlobDomain[0] = this->ni_glo;
+          nGlobDomain[1] = this->nj_glo;
+          for (int i = 0; i < nGlobDomain.size(); ++i) globalSizeIndex *= nGlobDomain[i];
+          indexBegin = 0;
+          if (globalSizeIndex <= clientSize)
+          {
+            indexBegin = rank%globalSizeIndex;
+            indexEnd = indexBegin;
+          }
+          else
+          {
+            for (int i = 0; i < clientSize; ++i)
+            {
+              range = globalSizeIndex / clientSize;
+              if (i < (globalSizeIndex%clientSize)) ++range;
+              if (i == client->clientRank) break;
+              indexBegin += range;
+            }
+            indexEnd = indexBegin + range - 1;
+          }
+
+          // Even if servers have no index, they must received something from client
+          // We only use several client to send "empty" message to these servers
+          CServerDistributionDescription serverDescription(nGlobDomain, nbServer);
+          std::vector<int> serverZeroIndex;
+          if (isUnstructed_) serverZeroIndex = serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t&,size_t&>(indexBegin, indexEnd), 0);
+          else serverZeroIndex = serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t&,size_t&>(indexBegin, indexEnd), 1);
+
+          std::list<int> serverZeroIndexLeader;
+          std::list<int> serverZeroIndexNotLeader;
+          CContextClient::computeLeader(client->clientRank, client->clientSize, serverZeroIndex.size(), serverZeroIndexLeader, serverZeroIndexNotLeader);
+          for (std::list<int>::iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
+            *it = serverZeroIndex[*it];
+
+          CClientServerMapping* clientServerMap = new CClientServerMappingDistributed(serverDescription.getGlobalIndexRange(), client->intraComm);
+          clientServerMap->computeServerIndexMapping(globalIndexDomain, nbServer);
+          CClientServerMapping::GlobalIndexMap& globalIndexDomainOnServer = clientServerMap->getGlobalIndexOnServer();
+
+          CClientServerMapping::GlobalIndexMap::const_iterator it  = globalIndexDomainOnServer.begin(),
                  ite = globalIndexDomainOnServer.end();
-           indSrv_[nbServer].swap(globalIndexDomainOnServer);
-           connectedServerRank_[nbServer].clear();
-           for (it = indSrv_[nbServer].begin(); it != ite; ++it)
-             connectedServerRank_[nbServer].push_back(it->first);
-
-           for (std::list<int>::const_iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
-              connectedServerRank_[nbServer].push_back(*it);
-
-           // Even if a client has no index, it must connect to at least one server and
-           // send an "empty" data to this server
-           if (connectedServerRank_[nbServer].empty())
-              connectedServerRank_[nbServer].push_back(client->clientRank % client->serverSize);
-
-           nbSenders[nbServer] = clientServerMap->computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_[nbServer]);
-           delete clientServerMap;
+          indSrv_[nbServer].swap(globalIndexDomainOnServer);
+          connectedServerRank_[nbServer].clear();
+          for (it = indSrv_[nbServer].begin(); it != ite; ++it)
+            connectedServerRank_[nbServer].push_back(it->first);
+
+          for (std::list<int>::const_iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
+            connectedServerRank_[nbServer].push_back(*it);
+
+          // Even if a client has no index, it must connect to at least one server and
+          // send an "empty" data to this server
+          if (connectedServerRank_[nbServer].empty())
+            connectedServerRank_[nbServer].push_back(client->clientRank % client->serverSize);
+
+          // Now check if all servers have data to receive. If not, master client will send empty data.
+          // This ensures that all servers will participate in collective calls upon receiving even if they have no date to receive.
+          std::vector<int> counts (clientSize);
+          std::vector<int> displs (clientSize);
+          displs[0] = 0;
+          int localCount = connectedServerRank_[nbServer].size() ;
+          ep_lib::MPI_Gather(&localCount, 1, EP_INT, &counts[0], 1, EP_INT, 0, client->intraComm) ;
+          for (int i = 0; i < clientSize-1; ++i)
+          {
+            displs[i+1] = displs[i] + counts[i];
+          }
+          std::vector<int> allConnectedServers(displs[clientSize-1]+counts[clientSize-1]);
+          ep_lib::MPI_Gatherv(&(connectedServerRank_[nbServer])[0], localCount, EP_INT, &allConnectedServers[0], &counts[0], &displs[0], EP_INT, 0, client->intraComm);
+
+          if ((allConnectedServers.size() != nbServer) && (rank == 0))
+          {
+            std::vector<bool> isSrvConnected (nbServer, false);
+            for (int i = 0; i < allConnectedServers.size(); ++i) isSrvConnected[allConnectedServers[i]] = true;
+            for (int i = 0; i < nbServer; ++i)
+            {
+              if (!isSrvConnected[i]) connectedServerRank_[nbServer].push_back(i);
+            }
+          }
+          nbSenders[nbServer] = clientServerMap->computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_[nbServer]);
+          delete clientServerMap;
         }
       }
     }
   }
+  CATCH_DUMP_ATTR
 
    /*!
@@ -1892,4 +1963,5 @@
    */
    void CDomain::computeWrittenIndex()
+   TRY
    {  
       if (computedWrittenIndex_) return;
@@ -1900,6 +1972,6 @@
 
       std::vector<int> nBegin(2), nSize(2), nBeginGlobal(2), nGlob(2);
-      nBegin[0]       = zoom_ibegin;  nBegin[1] = zoom_jbegin;
-      nSize[0]        = zoom_ni;      nSize[1]  = zoom_nj;
+      nBegin[0]       = ibegin;  nBegin[1] = jbegin;
+      nSize[0]        = ni;      nSize[1]  = nj;
       nBeginGlobal[0] = 0; nBeginGlobal[1] = 0;
       nGlob[0]        = ni_glo;   nGlob[1] = nj_glo;
@@ -1913,16 +1985,5 @@
                                        itSrve = writtenGlobalIndex.end(), itSrv;
 
-//      for (itSrv = itSrvb; itSrv != itSrve; ++itSrv)
-//      {
-//        indGlo = *itSrv;
-//        if (ite != globalLocalIndexMap_.find(indGlo))
-//        {
-//          ++nbWritten;
-//        }
-//      }
-
-//      localIndexToWriteOnServer.resize(nbWritten);
       localIndexToWriteOnServer.resize(writtenGlobalIndex.numElements());
-
       nbWritten = 0;
       for (itSrv = itSrvb; itSrv != itSrve; ++itSrv)
@@ -1932,15 +1993,16 @@
         {
           localIndexToWriteOnServer(nbWritten) = globalLocalIndexMap_[indGlo];
-          ++nbWritten;
         }
         else
         {
-          localIndexToWriteOnServer(nbWritten) = 0;
-          ++nbWritten;
-        }
-      }
-   }
+          localIndexToWriteOnServer(nbWritten) = -1;
+        }
+        ++nbWritten;
+      }
+   }
+   CATCH_DUMP_ATTR
 
   void CDomain::computeWrittenCompressedIndex(ep_lib::MPI_Comm writtenComm)
+  TRY
   {
     int writtenCommSize;
@@ -1956,6 +2018,6 @@
 
       std::vector<int> nBegin(2), nSize(2), nBeginGlobal(2), nGlob(2);
-      nBegin[0]       = zoom_ibegin;  nBegin[1] = zoom_jbegin;
-      nSize[0]        = zoom_ni;      nSize[1]  = zoom_nj;
+      nBegin[0]       = ibegin;  nBegin[1] = jbegin;
+      nSize[0]        = ni;      nSize[1]  = nj;
       nBeginGlobal[0] = 0; nBeginGlobal[1] = 0;
       nGlob[0]        = ni_glo;   nGlob[1] = nj_glo;
@@ -2002,6 +2064,6 @@
       {
              
-        ep_lib::MPI_Allreduce(&numberWrittenIndexes_[writtenCommSize], &totalNumberWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
-        ep_lib::MPI_Scan(&numberWrittenIndexes_[writtenCommSize], &offsetWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
+        ep_lib::MPI_Allreduce(&numberWrittenIndexes_[writtenCommSize], &totalNumberWrittenIndexes_[writtenCommSize], 1, EP_INT, EP_SUM, writtenComm);
+        ep_lib::MPI_Scan(&numberWrittenIndexes_[writtenCommSize], &offsetWrittenIndexes_[writtenCommSize], 1, EP_INT, EP_SUM, writtenComm);
         offsetWrittenIndexes_[writtenCommSize] -= numberWrittenIndexes_[writtenCommSize];
       }
@@ -2010,4 +2072,5 @@
       }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2016,18 +2079,18 @@
   */
   void CDomain::sendAttributes()
+  TRY
   {
     sendDistributionAttributes();
     sendIndex();       
-    sendMask();
     sendLonLat();
     sendArea();    
     sendDataIndex();
   }
-
+  CATCH
   /*!
-    Send global index and zoom index from client to connected client(s)
-    zoom index can be smaller than global index
+    Send global index from client to connected client(s)
   */
   void CDomain::sendIndex()
+  TRY
   {
     int ns, n, i, j, ind, nv, idx;
@@ -2041,5 +2104,5 @@
 
       list<CMessage> list_msgsIndex;
-      list<CArray<int,1> > list_indZoom, list_writtenInd, list_indGlob;
+      list<CArray<int,1> > list_indGlob;
 
       std::unordered_map<int, vector<size_t> >::const_iterator itIndex, iteIndex;
@@ -2072,4 +2135,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2079,4 +2143,5 @@
   */
   void CDomain::sendDistributionAttributes(void)
+  TRY
   {
     std::list<CContextClient*>::iterator it;
@@ -2115,5 +2180,5 @@
           msg << isUnstructed_;
           msg << ni_srv << ibegin_srv << nj_srv << jbegin_srv;
-          msg << global_zoom_ni.getValue() << global_zoom_ibegin.getValue() << global_zoom_nj.getValue() << global_zoom_jbegin.getValue();        
+          msg << ni_glo.getValue() << nj_glo.getValue();
           msg << isCompressible_;
 
@@ -2125,48 +2190,5 @@
     }
   }
-
-  /*!
-    Send mask index from client to connected(s) clients    
-  */
-  void CDomain::sendMask()
-  {
-    int ns, n, i, j, ind, nv, idx;
-    std::list<CContextClient*>::iterator it;
-    for (it=clients.begin(); it!=clients.end(); ++it)
-    {
-      CContextClient* client = *it;
-      int serverSize = client->serverSize;
-
-      // send area for each connected server
-      CEventClient eventMask(getType(), EVENT_ID_MASK);
-
-      list<CMessage> list_msgsMask;
-      list<CArray<bool,1> > list_mask;
-
-      std::unordered_map<int, vector<size_t> >::const_iterator it, iteMap;
-      iteMap = indSrv_[serverSize].end();
-      for (int k = 0; k < connectedServerRank_[serverSize].size(); ++k)
-      {
-        int nbData = 0;
-        int rank = connectedServerRank_[serverSize][k];
-        it = indSrv_[serverSize].find(rank);
-        if (iteMap != it)
-          nbData = it->second.size();
-        list_mask.push_back(CArray<bool,1>(nbData));
-
-        const std::vector<size_t>& temp = it->second;
-        for (n = 0; n < nbData; ++n)
-        {
-          idx = static_cast<int>(it->second[n]);
-          list_mask.back()(n) = domainMask(globalLocalIndexMap_[idx]);
-        }
-
-        list_msgsMask.push_back(CMessage());
-        list_msgsMask.back() << this->getId() << list_mask.back();
-        eventMask.push(rank, nbSenders[serverSize][rank], list_msgsMask.back());
-      }
-      client->sendEvent(eventMask);
-    }
-  }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2174,4 +2196,5 @@
   */
   void CDomain::sendArea()
+  TRY
   {
     if (!hasArea) return;
@@ -2217,4 +2240,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2224,4 +2248,5 @@
   */
   void CDomain::sendLonLat()
+  TRY
   {
     if (!hasLonLat) return;
@@ -2312,4 +2337,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2320,4 +2346,5 @@
   */
   void CDomain::sendDataIndex()
+  TRY
   {
     int ns, n, i, j, ind, nv, idx;
@@ -2388,6 +2415,8 @@
     }
   }
+  CATCH
   
   bool CDomain::dispatchEvent(CEventServer& event)
+  TRY
   {
     if (SuperClass::dispatchEvent(event)) return true;
@@ -2402,8 +2431,4 @@
         case EVENT_ID_INDEX:
           recvIndex(event);
-          return true;
-          break;
-        case EVENT_ID_MASK:
-          recvMask(event);
           return true;
           break;
@@ -2431,4 +2456,5 @@
     }
   }
+  CATCH
 
   /*!
@@ -2437,4 +2463,5 @@
   */
   void CDomain::recvIndex(CEventServer& event)
+  TRY
   {
     string domainId;
@@ -2450,4 +2477,5 @@
     get(domainId)->recvIndex(rankBuffers);
   }
+  CATCH
 
   /*!
@@ -2457,4 +2485,5 @@
   */
   void CDomain::recvIndex(std::map<int, CBufferIn*>& rankBuffers)
+  TRY
   {
     int nbReceived = rankBuffers.size(), i, ind, index, type_int, iIndex, jIndex;
@@ -2495,15 +2524,8 @@
            jIndex = (jIndex < 0) ? 0 : jIndex;
            nbIndLoc = iIndex + ni * jIndex;
-           if (nbIndLoc < nbIndexGlobMax)
-           {
-             i_index(nbIndLoc) = index % ni_glo;
-             j_index(nbIndLoc) = index / ni_glo;
-             globalLocalIndexMap_[index] = nbIndLoc;  
-             ++nbIndGlob;
-           }
-           // i_index(nbIndGlob) = index % ni_glo;
-           // j_index(nbIndGlob) = index / ni_glo;
-           // globalLocalIndexMap_[index] = nbIndGlob;  
-           // ++nbIndGlob;
+           i_index(nbIndGlob) = index % ni_glo;
+           j_index(nbIndGlob) = index / ni_glo;
+           globalLocalIndexMap_[index] = nbIndGlob;
+           ++nbIndGlob;
          } 
       } 
@@ -2520,5 +2542,8 @@
       j_index.resizeAndPreserve(nbIndGlob);
     }
+
+    domainMask.resize(0); // Mask is not defined anymore on servers
   }
+  CATCH
 
   /*!
@@ -2527,4 +2552,5 @@
   */
   void CDomain::recvDistributionAttributes(CEventServer& event)
+  TRY
   {
     CBufferIn* buffer=event.subEvents.begin()->buffer;
@@ -2533,117 +2559,29 @@
     get(domainId)->recvDistributionAttributes(*buffer);
   }
+  CATCH
 
   /*!
-    Receive attributes from client(s): zoom info and begin and n of each server
+    Receive attributes from client(s)
     \param[in] rank rank of client source
     \param[in] buffer message containing attributes info
   */
   void CDomain::recvDistributionAttributes(CBufferIn& buffer)
+  TRY
   {
     int ni_tmp, ibegin_tmp, nj_tmp, jbegin_tmp;
-    int global_zoom_ni_tmp, global_zoom_ibegin_tmp, global_zoom_nj_tmp, global_zoom_jbegin_tmp;
+    int ni_glo_tmp, nj_glo_tmp;
     buffer >> isUnstructed_ >> ni_tmp >> ibegin_tmp >> nj_tmp >> jbegin_tmp
-           >> global_zoom_ni_tmp >> global_zoom_ibegin_tmp >> global_zoom_nj_tmp >> global_zoom_jbegin_tmp           
+           >> ni_glo_tmp >> nj_glo_tmp
            >> isCompressible_;
+
     ni.setValue(ni_tmp);
     ibegin.setValue(ibegin_tmp);
     nj.setValue(nj_tmp);
     jbegin.setValue(jbegin_tmp);
-
-    global_zoom_ni.setValue(global_zoom_ni_tmp);
-    global_zoom_ibegin.setValue(global_zoom_ibegin_tmp);
-    global_zoom_nj.setValue(global_zoom_nj_tmp);
-    global_zoom_jbegin.setValue(global_zoom_jbegin_tmp);
-
-    int iend = ibegin + ni  - 1;
-    int jend = jbegin + nj  - 1;
-    int zoom_iend_glob = global_zoom_ibegin + global_zoom_ni - 1;
-    int zoom_jend_glob = global_zoom_jbegin + global_zoom_nj - 1;
-
-    zoom_ibegin.setValue(global_zoom_ibegin > ibegin ? global_zoom_ibegin.getValue() : ibegin);
-    int zoom_iend = zoom_iend_glob < iend ? zoom_iend_glob : iend ;
-    zoom_ni.setValue(zoom_iend-zoom_ibegin+1);
-
-    zoom_jbegin.setValue(global_zoom_jbegin > jbegin ? global_zoom_jbegin.getValue() : jbegin);
-    int zoom_jend = zoom_jend_glob < jend ? zoom_jend_glob : jend ;
-    zoom_nj.setValue(zoom_jend-zoom_jbegin+1);
-
-    if (zoom_ni<=0 || zoom_nj<=0)
-    {
-      zoom_ni=0 ; zoom_ibegin=global_zoom_ibegin ; //=0; zoom_iend=0 ; 
-      zoom_nj=0 ; zoom_jbegin=global_zoom_jbegin ; //=0; zoom_jend=0 ;
-    }
+    ni_glo.setValue(ni_glo_tmp);
+    nj_glo.setValue(nj_glo_tmp);
 
   }
-
-  /*!
-    Receive area event from clients(s)
-    \param[in] event event contain info about rank and associated area
-  */
-  void CDomain::recvMask(CEventServer& event)
-  {
-    string domainId;
-    std::map<int, CBufferIn*> rankBuffers;
-
-    list<CEventServer::SSubEvent>::iterator it;
-    for (it = event.subEvents.begin(); it != event.subEvents.end(); ++it)
-    {      
-      CBufferIn* buffer = it->buffer;
-      *buffer >> domainId;
-      rankBuffers[it->rank] = buffer;     
-    }
-    get(domainId)->recvMask(rankBuffers);
-  }
-
-
-  /*!
-    Receive mask information from client(s)
-    \param[in] rankBuffers rank of sending client and the corresponding receive buffer  
-  */
-  void CDomain::recvMask(std::map<int, CBufferIn*>& rankBuffers)
-  {
-    int nbReceived = rankBuffers.size(), i, ind, index, lInd;
-    if (nbReceived != recvClientRanks_.size())
-      ERROR("void CDomain::recvMask(std::map<int, CBufferIn*>& rankBuffers)",
-           << "The number of sending clients is not correct."
-           << "Expected number: " << recvClientRanks_.size() << " but received " << nbReceived);
-
-    vector<CArray<bool,1> > recvMaskValue(nbReceived);      
-    for (i = 0; i < recvClientRanks_.size(); ++i)
-    {
-      int rank = recvClientRanks_[i];
-      CBufferIn& buffer = *(rankBuffers[rank]);      
-      buffer >> recvMaskValue[i];
-    }
-
-    int nbMaskInd = 0;
-    for (i = 0; i < nbReceived; ++i)
-    {
-      nbMaskInd += recvMaskValue[i].numElements();
-    }
-  
-    if (nbMaskInd != globalLocalIndexMap_.size())
-      info (0) << "If domain " << this->getDomainOutputName() <<" does not have overlapped regions between processes "
-               << "something must be wrong with mask index "<< std::endl;
-
-    nbMaskInd = globalLocalIndexMap_.size();
-    mask_1d.resize(nbMaskInd);
-    domainMask.resize(nbMaskInd);
-    mask_1d = false;
-    
-    for (i = 0; i < nbReceived; ++i)
-    {
-      CArray<int,1>& tmpInd = indGlob_[recvClientRanks_[i]];
-      CArray<bool,1>& tmp = recvMaskValue[i];
-      for (ind = 0; ind < tmp.numElements(); ++ind)
-      {
-        lInd = globalLocalIndexMap_[size_t(tmpInd(ind))];
-        if (!mask_1d(lInd)) // Only rewrite mask_1d if it's not true
-          mask_1d(lInd) = tmp(ind);
-      }
-    }
-    domainMask=mask_1d ;
-  }
-
+ CATCH_DUMP_ATTR
   /*!
     Receive longitude event from clients(s)
@@ -2651,4 +2589,5 @@
   */
   void CDomain::recvLon(CEventServer& event)
+  TRY
   {
     string domainId;
@@ -2664,4 +2603,5 @@
     get(domainId)->recvLon(rankBuffers);
   }
+  CATCH
 
   /*!
@@ -2670,4 +2610,5 @@
   */
   void CDomain::recvLon(std::map<int, CBufferIn*>& rankBuffers)
+  TRY
   {
     int nbReceived = rankBuffers.size(), i, ind, index, iindex, jindex, lInd;
@@ -2729,4 +2670,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2735,4 +2677,5 @@
   */
   void CDomain::recvLat(CEventServer& event)
+  TRY
   {
     string domainId;
@@ -2748,4 +2691,5 @@
     get(domainId)->recvLat(rankBuffers);
   }
+  CATCH
 
   /*!
@@ -2754,4 +2698,5 @@
   */
   void CDomain::recvLat(std::map<int, CBufferIn*>& rankBuffers)
+  TRY
   {
     int nbReceived = rankBuffers.size(), i, ind, index, iindex, jindex, lInd;
@@ -2815,4 +2760,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2821,4 +2767,5 @@
   */
   void CDomain::recvArea(CEventServer& event)
+  TRY
   {
     string domainId;
@@ -2834,4 +2781,5 @@
     get(domainId)->recvArea(rankBuffers);
   }
+  CATCH
 
   /*!
@@ -2840,4 +2788,5 @@
   */
   void CDomain::recvArea(std::map<int, CBufferIn*>& rankBuffers)
+  TRY
   {
     int nbReceived = rankBuffers.size(), i, ind, index, lInd;
@@ -2885,4 +2834,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2894,4 +2844,5 @@
   */
   bool CDomain::isEqual(CDomain* obj)
+  TRY
   {
     vector<StdString> excludedAttr;
@@ -2916,4 +2867,5 @@
     return objEqual;
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -2922,4 +2874,5 @@
   */
   void CDomain::recvDataIndex(CEventServer& event)
+  TRY
   {
     string domainId;
@@ -2935,4 +2888,5 @@
     get(domainId)->recvDataIndex(rankBuffers);
   }
+  CATCH
 
   /*!
@@ -2946,4 +2900,5 @@
   */
   void CDomain::recvDataIndex(std::map<int, CBufferIn*>& rankBuffers)
+  TRY
   {
     int nbReceived = rankBuffers.size(), i, ind, index, indexI, indexJ, type_int, lInd;    
@@ -2982,9 +2937,4 @@
          dataIIndex(lInd) = (-1 == dataIIndex(lInd)) ? tmpI(ind) : dataIIndex(lInd); // Only fill in dataIndex if there is no data
          dataJIndex(lInd) = (-1 == dataJIndex(lInd)) ? tmpJ(ind) : dataJIndex(lInd);  
-
-         if (!domainMask(lInd))   // Include mask info into data index on the RECEIVE getServerDimensionSizes    
-         {
-           dataIIndex(lInd) = dataJIndex(lInd) = -1;
-         }
       } 
     }
@@ -3017,10 +2967,13 @@
     data_jbegin.setValue(0);
   }
+  CATCH_DUMP_ATTR
 
   CTransformation<CDomain>* CDomain::addTransformation(ETranformationType transType, const StdString& id)
+  TRY
   {
     transformationMap_.push_back(std::make_pair(transType, CTransformation<CDomain>::createTransformation(transType,id)));
     return transformationMap_.back().second;
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -3029,7 +2982,9 @@
   */
   bool CDomain::hasTransformation()
+  TRY
   {
     return (!transformationMap_.empty());
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -3038,7 +2993,9 @@
   */
   void CDomain::setTransformations(const TransMapTypes& domTrans)
+  TRY
   {
     transformationMap_ = domTrans;
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -3047,9 +3004,12 @@
   */
   CDomain::TransMapTypes CDomain::getAllTransformations(void)
+  TRY
   {
     return transformationMap_;
   }
+  CATCH_DUMP_ATTR
 
   void CDomain::duplicateTransformation(CDomain* src)
+  TRY
   {
     if (src->hasTransformation())
@@ -3058,4 +3018,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -3063,4 +3024,5 @@
    */
   void CDomain::solveInheritanceTransformation()
+  TRY
   {
     if (hasTransformation() || !hasDirectDomainReference())
@@ -3079,6 +3041,8 @@
         refDomains[i]->setTransformations(domain->getAllTransformations());
   }
+  CATCH_DUMP_ATTR
 
   void CDomain::setContextClient(CContextClient* contextClient)
+  TRY
   {
     if (clientsSet.find(contextClient)==clientsSet.end())
@@ -3088,4 +3052,5 @@
     }
   }
+  CATCH_DUMP_ATTR
 
   /*!
@@ -3095,4 +3060,5 @@
   */
   void CDomain::parse(xml::CXMLNode & node)
+  TRY
   {
     SuperClass::parse(node);
@@ -3108,9 +3074,6 @@
 
         nodeElementName = node.getElementName();
-        if(transformationMapList_ptr == 0) initializeTransformationMap();
-
-        std::map<StdString, ETranformationType>::const_iterator ite = transformationMapList_ptr->end(), it;
-
-        it = transformationMapList_ptr->find(nodeElementName);
+        std::map<StdString, ETranformationType>::const_iterator ite = transformationMapList_.end(), it;
+        it = transformationMapList_.find(nodeElementName);
         if (ite != it)
         {
@@ -3128,4 +3091,5 @@
     }
   }
+  CATCH_DUMP_ATTR
    //----------------------------------------------------------------
 
